;************************************************************************************
;*   6 nasobny nezavisly MKO, cas napevno 5 sekund				    *
;*   Autor David Hankovec  DHservis - vvoj a vroba elektroniky na zakzku. 	    *
;*   http://home.tiscali.cz/dh_servis    					    *
;************************************************************************************    
    
    
      LIST P=16F628A, R=DEC    ; Use the PIC16F628 and decimal system 

        #include "P16F628A.INC"  ; Include header file 

        __config  _INTRC_OSC_NOCLKOUT &_LVP_OFF & _WDT_OFF & _PWRTE_ON & _BOREN_OFF & _CP_OFF & _DATA_CP_OFF & _MCLRE_OFF
    
   		
 ;Zapojeni: Pouze napajeni, bez krystalu a vnejsiho resetu. 
 
 ;Vstupy jsou :
 ;#define in1  PORTA,0 ;vyvod 17
;#define in2  PORTA,1 ;vyvod 18
;#define in3  PORTA,2 ;vyvod 1
;#define in4  PORTA,3 ;vyvod 2
;#define in5  PORTA,4 ;vyvod 3
;#define in6  PORTA,5 ;vyvod 4
;Vystupy jsou:
;--------------------------------------------
;#define out1  PORTB,0 ;vyvod 6
;#define out2  PORTB,1 ;vyvod 7
;#define out3  PORTB,2 ;vyvod 8
;#define out4  PORTB,3 ;vyvod 9
;#define out5  PORTB,4 ;vyvod 10
;#define out6  PORTB,5 ;vyvod 11

;Vstupy nutno osetrit proti GND cca pres 4k7. Cas nastaven na cca 5 sec, kazdy samozrejme nezavisle, muze byt rozdil mezi casy 20 msec.
;Spousteni kladnou urovni na vstupu, vygeneruje H na vystupu. Pokus je H na vstupu, a cas dobehne, vystup normalne spadne a az do doby dalsiho kladneho pulsu
;se nic nedeje. Nutno take radne zablokovat napajeni
 
 
 
;udelat preteceni po 20 msec. t.j. 20000, taktovani 0.000001 usec.
;predvolba B1E0
 		
 		

cas1	equ	20H	;
cas2	equ	21H	;
cas3	equ	22H	;
cas4	equ	23H	;
cas5	equ	24H	;
cas6	equ	25H

flags	equ	26H	;flagy casu
flags1	equ	27H	;kratkodoba pamet minuleho stavu bitu portu pro zjisteni vzestupne hrany
TMPW	equ	28H
TMPS	equ	29H


tik1	equ	00H	;cas1
tik2	equ 01H	;cas2
tik3	equ 02H	;cas3
tik4	equ 03H	;cas4
tik5	equ 04H	;cas5
tik6	equ 05H	;cas6

minuly_1	equ	00H
minuly_2	equ	01H
minuly_3	equ	02H
minuly_4	equ	03H
minuly_5	equ	04H	
minuly_6	equ	05H


;----------------OBSAZENI PORTU-----------------------------------
#define in1		PORTA,0	;vyvod 17
#define in2		PORTA,1	;vyvod 18
#define in3		PORTA,2	;vyvod 1
#define in4		PORTA,3	;vyvod 2
#define in5		PORTA,4	;vyvod 3
#define in6		PORTA,5	;vyvod 4

;--------------------------------------------
#define out1		PORTB,0	;vyvod 6
#define out2		PORTB,1	;vyvod 7
#define out3		PORTB,2	;vyvod 8
#define out4		PORTB,3	;vyvod 9
#define out5		PORTB,4	;vyvod 10
#define out6		PORTB,5	;vyvod 11



 ORG    0x000            ; Program starts at 0x000 
	goto init
	ORG 4			;preruseni
	goto int1


int1
;-------------uloz data-----------------
	movwf	TMPW		; ulozi W
	swapf	STATUS,W	; prohodi nibble STATUS a ulozi do W
	bcf	STATUS,RP0	; nastaveni banky 0
	movwf	TMPS		; ulozit STATUS
;---------------------------------------

	bcf		PIR1,TMR1IF			;nuluj flag
	call	predvolba
	
;testy na casovani jednotlivych timeru	
	
	btfsc	flags,tik1	
	call	odpocet1
	btfsc	flags,tik2	
	call	odpocet2
	btfsc	flags,tik3	
	call	odpocet3
	btfsc	flags,tik4	
	call	odpocet4
	btfsc	flags,tik5	
	call	odpocet5
	btfsc	flags,tik6	
	call	odpocet6

;----------natahni data zpet-----------------------
        
IntRet swapf TMPS,W ; pvodn registr STATUS do W 
  movwf STATUS ; navrcen registru STATUS 
  swapf TMPW,F ; prprava pvodnho registru W 
  swapf TMPW,W ; nvrat pvodnho registru W 
  retfie 



;casovani prvniho vstupu
odpocet1
	decfsz	cas1,F		;dekrementuj soft timer 1
	return		;navrat
	bcf	flags,tik1	;docasovani, shod priznak casovani
	bcf	out1		;vypni vystupni bit
	return		;navrat
;-------------------------------------
odpocet2
	decfsz	cas2,F		;dekrementuj soft timer 1
	return		;navrat
	bcf	flags,tik2	;docasovani, shod priznak casovani
	bcf	out2		;vypni vystupni bit
	return		;navrat
;-------------------------------------	
odpocet3
	decfsz	cas3,F		;dekrementuj soft timer 1
	return		;navrat
	bcf	flags,tik3	;docasovani, shod priznak casovani
	bcf	out3		;vypni vystupni bit
	return		;navrat
;-------------------------------------
odpocet4
	decfsz	cas4,F		;dekrementuj soft timer 1
	return		;navrat
	bcf	flags,tik4	;docasovani, shod priznak casovani
	bcf	out4		;vypni vystupni bit
	return		;navrat
;-------------------------------------
odpocet5
	decfsz	cas5,F		;dekrementuj soft timer 1
	return		;navrat
	bcf	flags,tik5	;docasovani, shod priznak casovani
	bcf	out5		;vypni vystupni bit
	return		;navrat
;-------------------------------------
odpocet6
	decfsz	cas6,F		;dekrementuj soft timer 1
	return		;navrat
	bcf	flags,tik6	;docasovani, shod priznak casovani
	bcf	out6		;vypni vystupni bit
	return		;navrat				
 ;-------------------------------------




; --------------------------------
; SET ANALOG/DIGITAL INPUTS PORT A
; --------------------------------
;
init	movlw 7
	movwf CMCON		; CMCON=7 set comparators off         
; 
; ---------------- 
; INITIALIZE PORTS
; ---------------- 
; 
	bcf STATUS,RP0		;banka 0
	movlw b'00000000'   ;set up portA
	movwf PORTA	
        
	movlw b'00000000'	; 
    movwf PORTB

        bsf STATUS,RP0          ; RAM PAGE 1
		bcf OPTION_REG, 7		; enable internal pullups

;----------PORT A-----------------------
        movlw b'00111111'
        movwf TRISA		; portA

;----------PORT B-----------------------
       movlw b'00000000'	;  outputs 
       movwf TRISB

		bcf	STATUS,RP0
		bcf	STATUS,IRP	;



;nastaveni TMR1	
		bcf		T1CON,T1CKPS1	;preddelicka 1:8
		bcf		T1CON,T1CKPS0	
		bcf		T1CON,TMR1CS	;taktovano oscilatorem
		bsf		T1CON,TMR1ON	;spust
	
		bsf STATUS,RP0          ; RAM PAGE 1
		bsf	PIE1,TMR1IE			;povolit INT od preteceni timeru 1
		bcf STATUS,RP0          ; RAM PAGE 0


;-----------INTERRUPT------------------
	bcf	INTCON,INTF
	bsf INTCON, PEIE ; Enable all unmasked Peripheral Interrupts
	bsf INTCON, GIE ; Enable all Interrupts

start
	clrf		flags

opak
	btfss	in1				;testuj vstup, v H je aktivni
	goto	opak_1					
	call	aktiv1				;aktivni, testuj odpocet casu
	goto	opak_11
opak_1	
	bcf	flags1,minuly_1			;uloz stav bitu portu
opak_11
;-------------------------------------
	btfss	in2
	goto	opak_2
	call	aktiv2
	goto	opak_22	
opak_2
	bcf	flags1,minuly_2			;uloz stav bitu portu
opak_22
;------------------------------------
	btfss	in3
	goto	opak_3
	call	aktiv3
	goto	opak_33	
opak_3
	bcf	flags1,minuly_3			;uloz stav bitu portu
opak_33
;-------------------------------------
	btfss	in4
	goto	opak_4
	call	aktiv4
	goto	opak_44	
opak_4
	bcf	flags1,minuly_4			;uloz stav bitu portu
opak_44
;-------------------------------------
	btfss	in5
	goto	opak_5
	call	aktiv5
	goto	opak_55	
opak_5
	bcf	flags1,minuly_5			;uloz stav bitu portu
opak_55
;-------------------------------------
	btfss	in6
	goto	opak_6
	call	aktiv6
	goto	opak_66
opak_6
	bcf	flags1,minuly_6			;uloz stav bitu portu
opak_66
;-------------------------------------
	goto	opak
;-------------------------------------

aktiv1
;vstup1 v H
	btfsc	flags1,minuly_1				;porovnej s minulym stavem
	return						;stav nemenen, zpatky
	bsf	flags1,minuly_1				;aktualizuj pamet stavu
	btfsc	flags,tik1				;testuj docasovani
	return						;pokud je v H, casuje se, navrat
	movlw	#250D
	movwf	cas1					;nacti predvolbu soft. casovace
	bsf	flags,tik1				;spust casovani v INT
	bsf	out1					;zapni vystupni bit
	return	
;-------------------------------------

aktiv2
;vstup1 v H
	btfsc	flags1,minuly_2				;porovnej s minulym stavem
	return						;stav nemenen, zpatky
	bsf	flags1,minuly_2				;aktualizuj pamet stavu
	btfsc	flags,tik2				;testuj docasovani
	return						;pokud je v H, casuje se, navrat
	movlw	#250D
	movwf	cas2					;nacti predvolbu soft. casovace
	bsf	flags,tik2				;spust casovani v INT
	bsf	out2					;zapni vystupni bit
	return	
;-------------------------------------

aktiv3
;vstup1 v H
	btfsc	flags1,minuly_3				;porovnej s minulym stavem
	return						;stav nemenen, zpatky
	bsf	flags1,minuly_3				;aktualizuj pamet stavu
	btfsc	flags,tik3				;testuj docasovani
	return						;pokud je v H, casuje se, navrat
	movlw	#250D
	movwf	cas3					;nacti predvolbu soft. casovace
	bsf	flags,tik3				;spust casovani v INT
	bsf	out3					;zapni vystupni bit
	return	
;-------------------------------------	
aktiv4
;vstup1 v H
	btfsc	flags1,minuly_4				;porovnej s minulym stavem
	return						;stav nemenen, zpatky
	bsf	flags1,minuly_4				;aktualizuj pamet stavu
	btfsc	flags,tik4				;testuj docasovani
	return						;pokud je v H, casuje se, navrat
	movlw	#250D
	movwf	cas4					;nacti predvolbu soft. casovace
	bsf	flags,tik4				;spust casovani v INT
	bsf	out4					;zapni vystupni bit
	return	
;-------------------------------------	
aktiv5
;vstup1 v H
	btfsc	flags1,minuly_5				;porovnej s minulym stavem
	return						;stav nemenen, zpatky
	bsf	flags1,minuly_5				;aktualizuj pamet stavu
	btfsc	flags,tik5				;testuj docasovani
	return						;pokud je v H, casuje se, navrat
	movlw	#250D
	movwf	cas5					;nacti predvolbu soft. casovace
	bsf	flags,tik5				;spust casovani v INT
	bsf	out5					;zapni vystupni bit
	return	
;-------------------------------------	
aktiv6
;vstup1 v H
	btfsc	flags1,minuly_6				;porovnej s minulym stavem
	return						;stav nemenen, zpatky
	bsf	flags1,minuly_6				;aktualizuj pamet stavu
	btfsc	flags,tik6				;testuj docasovani
	return						;pokud je v H, casuje se, navrat
	movlw	#250D
	movwf	cas6					;nacti predvolbu soft. casovace
	bsf	flags,tik6				;spust casovani v INT
	bsf	out6					;zapni vystupni bit
	return	
;-------------------------------------


predvolba
	movlw	0B1H
	movwf	TMR1H
	movlw	0E0H
	movwf	TMR1L
	return


  
        END
